DECLARE SUB Result ()
'~CodeStart: QB45 /L Future45 /H
'$INCLUDE: 'Future.Bi'

CONST Res = 21
CONST Bits = 4

DIM SHARED Resolutions(1 TO Res) AS STRING
DIM SHARED BitDepths(1 TO Bits) AS STRING
DIM SHARED Results(1 TO Res, 1 TO Bits) AS INTEGER
DIM SHARED TotalResources AS INTEGER

SCREEN 0, 1, 0, 0
WIDTH 80, 25
VIEW PRINT
COLOR 15, 1
CLS
PRINT
PRINT " VESA SVGA Mode Test v1 for Future.Library"
PRINT " Coded By: William Scott"
PRINT " Email: William_Scott@HotMail.Com"
PRINT " ICQ: 75918687"
PRINT
PRINT
PRINT "  This is yet another lame program created by me out of bordom. =p"
PRINT
PRINT "  Use this program to view all of your VESA SVGA configurations possible"
PRINT " on your PC. This test may take some minutes to compleate so please be"
PRINT " patient. Please note that you might need UNIVBE.EXE from www.scitechsoft.com"
PRINT " in order to use VESA SVGA."

LOCATE 24, 2
PRINT "Press a key to begin or <ESC> to quit."
K$ = INPUT$(1)
IF K$ = CHR$(27) THEN GOTO Quit

LOCATE 24, 2

IF IsVESA THEN
 PRINT "Detecting modes... Please Wait.       "
ELSE
 PRINT " VESA SVGA is not suported... Please install UNIVBE.EXE   [Press a key]"
 K$ = INPUT$(1)
 GOTO Quit
END IF

RESTORE ResolutionData
FOR Redo = 1 TO Res
 READ Resolutions(Redo)
NEXT

RESTORE ColorDepthData
FOR Redo = 1 TO Bits
 READ BitDepths(Redo)
NEXT

FOR Redo = 1 TO Res
 FOR Redo2 = 1 TO Bits
  Results(Redo, Redo2) = -1
 NEXT
NEXT

FOR Redo = 1 TO Res
 FOR Redo2 = 1 TO Bits
  FOR Redo3 = 0 TO 1024
   ModeFound$ = Future.ModeList$(Redo3)
   IF ModeFound$ = "" THEN EXIT FOR
   IF INSTR(ModeFound$, Resolutions(Redo) + BitDepths(Redo2)) <> 0 THEN
    SELECT CASE Redo2
     CASE 1: B = 8
     CASE 2: B = 15
     CASE 3: B = 16
     CASE 4: B = 32
    END SELECT

    SELECT CASE Redo

     CASE 1: Set320x200 (B)
     CASE 2: Set320x240 (B)
     CASE 3: Set320x400 (B)
     CASE 4: Set320x480 (B)
     CASE 5: Set400x300 (B)
     CASE 6: Set512x384 (B)
     CASE 7: Set640x350 (B)
     CASE 8: Set640x400 (B)
     CASE 9: Set640x480 (B)
     CASE 10: Set720x480 (B)
     CASE 11: Set720x576 (B)
     CASE 12: Set800x600 (B)
     CASE 13: Set1024x768 (B)
     CASE 14: Set1152x864 (B)
     CASE 15: Set1280x960 (B)
     CASE 16: Set1280x1024 (B)
     CASE 17: Set1600x1200 (B)
     CASE 18: Set1920x1080 (B)
     CASE 19: Set1920x1200 (B)
     CASE 20: Set1920x1440 (B)
     CASE 21: Set2048x1536 (B)
   END SELECT

    Pagez = Pages
    Results(Redo, Redo2) = Pagez
    IF B > 8 THEN
     Future.Print 0, 0, "Mode Found:" + Resolutions(Redo) + BitDepths(Redo2) + " - " + "(0-" + LTRIM$(STR$(Pagez)) + ")", RGB2Color(255, 255, 255), -1
    ELSE
     Future.Print 0, 0, "Mode Found:" + Resolutions(Redo) + BitDepths(Redo2) + " - " + "(0-" + LTRIM$(STR$(Pagez)) + ")", 15, -1
    END IF

    TotalResources = TotalResources + 1
    EXIT FOR
   END IF
  NEXT
 NEXT
NEXT

Result

ResolutionData:
DATA "320x200"
DATA "320x240"
DATA "320x400"
DATA "320x480"
DATA "400x300"
DATA "512x384"
DATA "640x350"
DATA "640x400"
DATA "640x480"
DATA "720x480"
DATA "720x576"
DATA "800x600"
DATA "1024x768"
DATA "1152x864"
DATA "1280x960"
DATA "1280x1024"
DATA "1600x1200"
DATA "1920x1080"
DATA "1920x1200"
DATA "1920x1440"
DATA "2048x1536"

ColorDepthData:
DATA " 8 Bit"
DATA " 15 Bit"
DATA " 16 Bit"
DATA " 32 Bit"

Quit:
ResetScreen
SCREEN 0, 1, 0, 0
WIDTH 80, 25
VIEW PRINT
COLOR 7, 0
CLS
SYSTEM

SUB Result
ResetScreen
SCREEN 0, 1, 0, 0
WIDTH 80, 50
VIEW PRINT
COLOR 15, 1
CLS
PRINT "  "; STRING$(74, ""); ""
PRINT "  "; TAB(78); ""

PRINT "  ";
FOR Redo = 1 TO 4
 PRINT STRING$(14, ""); "";
NEXT
PRINT STRING$(14, ""); ""

FOR Redo = 1 TO 22
 PRINT "  ";
 FOR Redo2 = 1 TO 5
  PRINT SPACE$(14); "";
 NEXT
 PRINT

 PRINT "  ";
 FOR Redo2 = 1 TO 4
  PRINT STRING$(14, ""); "";
 NEXT
 PRINT STRING$(14, ""); "";
NEXT
LOCATE CSRLIN, 1

 PRINT "  ";
 FOR Redo2 = 1 TO 4
  PRINT STRING$(14, ""); "";
 NEXT
 PRINT STRING$(14, ""); "";

PRINT "  "; TAB(78); ""
PRINT "  "; TAB(78); ""
PRINT "  "; STRING$(74, ""); "";

T$ = "Results:"
'COLOR 14
LOCATE 2, 40 - LEN(T$) / 2
PRINT T$
COLOR 11
LOCATE 4, 5
PRINT "Resolutions";
LOCATE , 24
PRINT "8 Bit";
LOCATE , 38
PRINT "15 Bit";
LOCATE , 53
PRINT "16 Bit";
LOCATE , 68
PRINT "32 Bit"
PRINT

COLOR 14
FOR Redo = 1 TO 21
 LOCATE 4 + (2 * Redo), 6
 PRINT Resolutions(Redo)
NEXT

'SLEEP
'EXIT SUB

FOR Redo = 1 TO Res
 FOR Redo2 = 1 TO Bits
  LOCATE 4 + (2 * Redo), 4 + (15 * Redo2)
  IF Results(Redo, Redo2) <> -1 THEN
   COLOR 10
   PRINT Results(Redo, Redo2) + 1; "Page (0-"; LTRIM$(STR$(Results(Redo, Redo2))); ")"
  ELSE
   COLOR 7
   PRINT " Unsupported!"
  END IF
 NEXT
NEXT

COLOR 11
LOCATE 48, 9
PRINT LTRIM$(RTRIM$(STR$(INT((TotalResources / (Res * Bits)) * 100))));
PRINT "% of Future.Library's VESA SVGA modes are available to you."
LOCATE 49, 9
PRINT "Keep on programming and have a nice day!  =)   [Press a key]"
K$ = INPUT$(1)

END SUB

